# Copyright 2021-2023 H2020 TeraFlow (https://www.teraflow-h2020.eu/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

apiVersion: apps/v1
kind: Deployment
metadata:
  name: teservice
spec:
  selector:
    matchLabels:
      app: teservice
  template:
    metadata:
      labels:
        app: teservice
    spec:
      terminationGracePeriodSeconds: 5
      shareProcessNamespace: true
      containers:
      - name: server
        image: registry.gitlab.com/teraflow-h2020/controller/te:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 11010
        env:
        - name: ERLANG_LOGGER_LEVEL
          value: "debug"
        - name: ERLANG_COOKIE
          value: "tfte-unsafe-cookie"
        - name: ERLANG_NODE_NAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: ERLANG_NODE_IP
          valueFrom:
            fieldRef:
              fieldPath: status.podIP
        readinessProbe:
          exec:
            command: ["/tfte/bin/tfte", "status"]
        livenessProbe:
          grpc:
            port: 11010
        resources:
          requests:
            cpu: 250m
            memory: 512Mi
          limits:
            cpu: 700m
            memory: 1024Mi
---
apiVersion: v1
kind: Service
metadata:
  name: teservice
spec:
  type: ClusterIP
  selector:
    app: teservice
  ports:
  - name: grpc
    protocol: TCP
    port: 11010
    targetPort: 11010
  - name: pcep
    protocol: TCP
    port: 4189
    targetPort: 4189
